
#include <assert.h>
#include "bitmap.h"
#include <iostream>
#include <stdio.h>
#include<cstring>
#include<cstdlib>
#include"ezwin.h"

using namespace std;

void delete_student(int);
void print_database();
void add();
void search(int);
void modify_student(int);
void search_dept(char*dpt);


SimpleWindow W1("SIMS-Student Information Management System", 25.0, 15.0, Position(1.0, 1.0));
SimpleWindow W2("  SIMS  ",25.0, 20.0, Position(2.0, 2.0));





void delete_student(int rn){
        
        char string[10000];
        FILE* temp;
	temp=fopen("temp.txt","a");
	
        if(temp==NULL){
                cout<<"Error opening file to write\n";
                return;
                      }
	
    	FILE *info;
	    info=fopen("data.txt","r");
	    if(info==NULL){
	 	cout<<"file not found"<<endl;
		return ;
              	      }
            int found=0;   	
	int i=0,k=0,check=0;
	char sroll[10],sname[50],sdept[60],shostel[10],sdob[15];char scontact[15],scpi[10];
	fgets(string,9999,info);
	while(!feof(info))
	  {	
		int num=0;
		
		while(string[k]!=' ')
		 {
			sroll[i]=string[k];num=num*10+(string[k]-48);
			i++;
			k++;	
				
		  }
		sroll[i]='\0';i=0;k++;
		while(string[k]!=' ')
		   {
			sname[i]=string[k];
				i++;k++;
			   }
		sname[i]='\0';
		i=0;k++;
			while(string[k]!=' ')
			  {
				sdob[i]=string[k];
				i++;
				k++;
			  }
			sdob[i]='\0';i=0;k++;
			while(string[k]!=' ')
			  {
				scontact[i]=string[k];
				i++;
				k++;
			   }
			scontact[i]='\0';i=0;k++;
			while(string[k]!=' ')
			  {
				sdept[i]=string[k];
				i++;
				k++;
			   }
			sdept[i]='\0';i=0;
			k++;
			while(string[k]!=' ')
			  {
				shostel[i]=string[k];
				i++;
				k++;
			  }
			shostel[i]='\0';i=0;
			k++;
			while(string[k]!='\0')
			  {
				scpi[i]=string[k];
				i++;
				k++;
			   }
			scpi[i]='\0';i=0;k=0;  
        
       
           if(rn==num){
                        found=1;
                       cout<<"Student found in the database\n";
                }
                else { fprintf(temp,"%s %s %s %s %s %s %s\n",sroll,sname,sdept,shostel,sdob,scontact,scpi);}
                fgets(string,9999,info);
        }
        fclose(info);
        fclose(temp);
        remove("data.txt");
        rename("temp.txt","data.txt");
        if(found==1)cout<<"Student deleted from database\n";
        else cout<<"Student not found in the database\n";
        return;
}



void print_database(){

	char string[10000];
     FILE *info;
	info=fopen("data.txt","r");
	if(info==NULL)
	{	cout<<"file not found"<<endl;
		return ;
	}
	int i,k,count=0;
	char sroll[10],sname[50],sdept[60],shostel[10],sdob[15],scontact[15],scpi[10];
	fgets(string,9999,info);
	while(!feof(info))
	  {	
		i=0;k=0;
		while(string[k]!=' ')
		 {
			sroll[i]=string[k];
			i++;
			k++;			
		  }
		sroll[i]='\0';i=0;k++;
		while(string[k]!=' ')
		   {
			sname[i]=string[k];
				i++;k++;
			   }
		while(i<15)
		{ 
			sname[i]=' ';i++;
		}
		sname[i]='\0';
		i=0;k++;
		while(string[k]!=' ')
		  {
			sdept[i]=string[k];
			i++;
			k++;
		  }
		sdept[i]='\0';i=0;k++;
		while(string[k]!=' ')
		  {
			shostel[i]=string[k];
			i++;
			k++;
		  }
		shostel[i]='\0';i=0;k++;
		while(string[k]!=' ')
		  {
			sdob[i]=string[k];
			i++;
			k++;
		 }
		sdob[i]='\0';i=0;k++;
		while(string[k]!=' ')
		  {
			scontact[i]=string[k];
			i++;
			k++;
		  }
		scontact[i]='\0';i=0;k++;
		while(string[k]!='\0')
		  {
			scpi[i]=string[k];
			i++;
			k++;
		  }
		scpi[i]='\0';
     
     		cout<<sroll<<' '<<sname<<' '<<sdept<<' '<<shostel<<' '<<sdob<<' '<<scontact<<' '<<scpi<<' '<<endl;
          
        fgets(string,9999,info);        
        }
        fclose(info);
}

//upasana's program

class student{
	char stdntname[60];
	char stdntrollnumber[10];
	char stdntdepartment[60];
	char stdnthostel[5];
	char stdntDOB[10];
	int stdntcontactno;
	float stdntcpi;
	public:
	void setname(char*nm);
	void getname(char*nm);
	void setrollnumber(char*rn);
	void getrollnumber(char*rn);
	void setdepartment(char*dp);
	void getdepartment(char*dp);
	void sethostel(char*hn);
	void gethostel(char*hn);
	void setDOB(char*db);
	void getDOB(char*db);
	void setcontactno(int cn);
	int getcontactno();
	void setcpi(float cpi);
	float getcpi();
	};
void student::setname(char*nm)
  {
	strcpy(stdntname,nm);
  }
void student::setrollnumber(char*rn)
  {
 	strcpy(stdntrollnumber,rn);
  }
void student::setdepartment(char*dp)
  {
	strcpy(stdntdepartment,dp);
  }
void student::sethostel(char*hn)
  {
	strcpy(stdnthostel,hn);
  }
void student::setDOB(char*db)
  {
	strcpy(stdntDOB,db);
  }
void student::setcontactno(int cn)
  {
	stdntcontactno=cn;
  }
void student::setcpi(float cpi)
  {
	stdntcpi=cpi;
  } 
void student::getname(char*nm)
  {
	strcpy(nm, stdntname);
  }
void student::getdepartment(char*dp)
  {
	strcpy(dp, stdntdepartment);
  }
void student::getrollnumber(char*rn)
  {
	strcpy(rn, stdntrollnumber);
  }
void student::gethostel(char*hn)
  {
	strcpy(hn, stdnthostel);
  }
void student::getDOB(char*db)
  {
	strcpy(db, stdntDOB);
  }
int student::getcontactno()
  {
	return stdntcontactno;
  }
float student::getcpi()
  {
	return stdntcpi;
  }	


void add()
{
	student s;
	char sname[60],sroll[10],sdpt[60],shostel[5],sdob[10];int scntct;
	float scpi;
	FILE*fp;
	fp=fopen("data.txt","a");
	if(fp==NULL)
	  {
		cout<<"Error opening file\n";
		return ;
	  }
	 cout<<"enter name of the student without spaces: ";
	cin>>sname;
	s.setname(sname);
	s.getname(sname);
	 cout<<"Roll no.:";
	cin>>sroll;
	s.setrollnumber(sroll);
	s.getrollnumber(sroll);
	cout<<"enter department name without spaces\n";
	cin>>sdpt;
	s.setdepartment(sdpt);
	s.getdepartment(sdpt);
	cout<<"hostel : ";
	cin>>shostel;
	s.sethostel(shostel);
	s.gethostel(shostel);
	cout<<"D.O.B : ";
	cin>>sdob;
	s.setDOB(sdob);
	s.getDOB(sdob);
	 cout<<"Contact no.:";
	cin>>scntct;
	s.setcontactno(scntct);
	scntct=s.getcontactno();
	cout<<"C.P.I : ";
	cin>>scpi;
	s.setcpi(scpi);
	scpi=s.getcpi();
	fprintf(fp,"%s %s %s %s %s %d %f\n",sname,sroll,sdpt,shostel,sdob,scntct,scpi);
	cout<<"data written successfully\n";
	fclose(fp);
	return ;
}


//swati's program


void search(int roll){
	
	char string[10000];
	
	
	FILE *info;
	info=fopen("data.txt","r");
	if(info==NULL)
	{
       	cout<<"file not found"<<endl;
		return ;
	}
	int i=0,j, k=0,check=0;
	char sroll[10],sname[50],sdept[60],shostel[10],sdob[15];int numb;char scontact[15],scpi[10];
	fgets(string,9999,info);
	while(!feof(info))
	  {	
		numb=0;
		
		while(string[k]!=' ')
		 {
			sroll[i]=string[k];numb=numb*10+(string[k]-48);
			i++;
			k++;	
				
		  }
		sroll[i]='\0';i=0;k++;
		while(string[k]!=' ')
		   {
			sname[i]=string[k];
				i++;k++;
			   }
		while(i<15)
		{ 
			sname[i]=' ';i++;
		}
		sname[i]='\0';
		i=0;k++;
		while(string[k]!=' ')
			  {
				sdept[i]=string[k];
				i++;
				k++;
			   }
			sdept[i]='\0';i=0;
			k++;
			while(string[k]!=' ')
			  {
				shostel[i]=string[k];
				i++;
				k++;
			  }
			shostel[i]='\0';i=0;
			k++;
			while(string[k]!=' ')
			  {
				sdob[i]=string[k];
				i++;
				k++;
			  }
			sdob[i]='\0';i=0;k++;
			while(string[k]!=' ')
			  {
				scontact[i]=string[k];
				i++;
				k++;
			   }
			scontact[i]='\0';i=0;k++;
			
			
			while(string[k]!='\0')
			  {
				scpi[i]=string[k];
				i++;
				k++;
			   }
			scpi[i]='\0';i=0;k=0;
			if(numb==roll)
			{
			 check=0;
		 	
             cout<<"\n\t\tRoll :"<<numb<<"\n\t\t Name :"<<sname<<"\n\t\tD.O.B. :"<<sdob<<"n\t\t Contact no.:"<<scontact<<"\n\t\tDepartment :"<<sdept<<"\n\t\t Hostel :"<<shostel<<"\n\t\tC.P.I. :"<<scpi<<endl;
			break;
	  	     }
			else
			  {
				check+=1;
			  }
			fgets(string,9999,info);
		
	  }
	if(check!=0)
	cout<<"\tGiven roll does not exist"<<endl;
	fclose(info);
	return;
  }


//modified part of suraj's program

void modify_student(int rn){
		char string[10000];char outstring[10000];
		FILE *info;
	info=fopen("data.txt","r");
	if(info==NULL)
	{	cout<<"file not found"<<endl;
		return ;
	}
	
	FILE *temp;
	temp=fopen("temp.txt","a");
	if(temp==NULL){
		cout<<"Error opening file to write\n";
		return;
             	}
	
	
	int found=0;
    int i,k,count=0,numb=0;
	char sroll[10],sname[50],sdept[60],shostel[10],sdob[15],scontact[15],scpi[10];
	fgets(string,9999,info);
	while(!feof(info))
	  {	
		i=0;k=0;
		while(string[k]!=' ')
		 {
			sroll[i]=string[k];numb=numb*10+(string[k]-48);
			i++;
			k++;			
		  }
		sroll[i]='\0';i=0;k++;
		while(string[k]!=' ')
		   {
			sname[i]=string[k];
				i++;k++;
			   }
		sname[i]='\0';
		i=0;k++;
		while(string[k]!=' ')
		  {
			sdob[i]=string[k];
			i++;
			k++;
		 }
		sdob[i]='\0';i=0;k++;
		while(string[k]!=' ')
		  {
			scontact[i]=string[k];
			i++;
			k++;
		  }
		scontact[i]='\0';i=0;k++;
		while(string[k]!=' ')
		  {
			sdept[i]=string[k];
			i++;
			k++;
		  }
		sdept[i]='\0';i=0;k++;
		while(string[k]!=' ')
		  {
			shostel[i]=string[k];
			i++;
			k++;
		  }
		shostel[i]='\0';i=0;k++;
		while(string[k]!='\0')
		  {
			scpi[i]=string[k];
			i++;
			k++;
		  }
		scpi[i]='\0';
	   
		if(rn==numb){
			found=1;
			 cout<<"Student found in the database\n";
			 cout<<"enter modified hostel number:\n ";
			cin>>shostel;
			 cout<<"enter enter modified DOB :\n";
			cin>>sdob;
			cout<<"enter new contact number\n";
			cin>>scontact;
			cout<<"enter new cpi\n";
			cin>>scpi;
		}
		sprintf(outstring,"%s %s %s %s %s %s %s\n",sname,sroll,sdept,shostel,sdob,scontact,scpi);
		fputs(outstring,temp);
		fgets(string,9999,info);
	}
	fclose(info);
	fclose(temp);
	remove("data.txt");
	rename("temp.txt","data.txt");
	 if(found==1){ cout<<"\tStudent modified from database\n"; }
	else { cout<<"\tStudent not found in the database\n"; }
	return;
}


//dept search

void search_dept(char *dpt)
   {
	
	char string[10000];
	
	FILE *info;
	info=fopen("modify.txt","r");
	if(info==NULL)
	{	cout<<"file not found"<<endl;
		return ;
	}
	int i,k,count=0;
	char sroll[10],sname[50],sdept[60],shostel[10],sdob[15],scontact[15],scpi[10];
	fgets(string,9999,info);
	while(!feof(info))
	  {	
		i=0;k=0;
		while(string[k]!=' ')
		 {
			sroll[i]=string[k];
			i++;
			k++;			
		  }
		sroll[i]='\0';i=0;k++;
		while(string[k]!=' ')
		   {
			sname[i]=string[k];
				i++;k++;
			   }
		while(i<15)
		{ 
			sname[i]=' ';i++;
		}			
		sname[i]='\0';
		i=0;k++;
		while(string[k]!=' ')
		  {
			sdept[i]=string[k];
			i++;
			k++;
		  }
		sdept[i]='\0';i=0;k++;
		while(string[k]!=' ')
		  {
			shostel[i]=string[k];
			i++;
			k++;
		  }
		shostel[i]='\0';i=0;k++;
		while(string[k]!=' ')
		  {
			sdob[i]=string[k];
			i++;
			k++;
		 }
		
		sdob[i]='\0';i=0;k++;
		while(string[k]!=' ')
		  {
			scontact[i]=string[k];
			i++;
			k++;
		  }
		scontact[i]='\0';i=0;k++;
		
		
		
		while(string[k]!='\0')
		  {
			scpi[i]=string[k];
			i++;
			k++;
		  }
		scpi[i]='\0';
		if(strcmp(dpt,sdept)==0)
		{	  	   	
			  count+=1;
			  
			 cout<<count<<' ';
			 cout<<"roll :"<<sroll<<endl;
			 cout<<"Name :"<<sname<<endl;
			 cout<<"Department :"<<sdept<<endl;
			 cout<<"Hostel :"<<shostel<<endl;
			cout<<"Contact no. :"<<scontact<<endl;
		        cout<<"C.P.I :"<<scpi<<endl;
		  }
		fgets(string,9999,info);	
	  }
	if(count==0)
		cout<<"no student found"<<endl;
	fclose(info);
	return;
  
}


int ApiMain() {

	W1.Open();
	  assert(W1.GetStatus() == WindowOpen);    
    
   	   W1.RenderText(Position(6.0,6.0),Position(16,7),"Welcome to SIMS",Red);
 	    W1.RenderText(Position(6.0,8.0),Position(16,9),"Student login: Press s",Red);
   	   W1.RenderText(Position(6.0,10.0),Position(16,11),"Master login : press m",Red);
   
      char l;
      cin>>l; 
    
   if (l=='m') {
	W1.RenderText(Position(8.0,12.0),Position(16,14),"Enter the Master password:",Blue);

       int p;
       cin>>p;
       if(p==123456)
       {
         W1.Close();
         W2.Open();
	 assert(W2.GetStatus() == WindowOpen);    
 
         W2.RenderText(Position(2.0,2.0),Position(10,4)," < 1 > . Veiw student info. list  ",Blue);
    
         W2.RenderText(Position(2.0,4.0),Position(10,6)," < 2 > . Add students from the list  ",Blue);
      
         W2.RenderText(Position(2.0,6.0),Position(10,8)," < 3 > . Search for a student on Roll.no basis ",Blue);
       
	 W2.RenderText(Position(2.0,8.0),Position(10,10),"< 4 > . Remove a student from the list ",Blue);
     
	 W2.RenderText(Position(2.0,10.0),Position(10,12),"< 5 > . Edit an existing students information ",Blue);
    
         W2.RenderText(Position(4.0,11.0),Position(10,14)," Press the number before to got to the coressponding function: ",Magenta); 
       
      int c; 
      cin>>c;
	W2.Close();



    switch(c)
    {
        case 1 :
	   {
	    print_database();break;
           }
	case 2 :
     	  {
           add();break;
          }
	case 3 :
     	  {
        	int roll;
            
             cout<<"\t\t enter your roll no."<<endl;
           	cin>>roll;
       	    if(roll/100000000!=1 || roll%1000000000!=roll)
	      {
	    	
                cout<<"\t\t invalid roll"<<endl;return -1;
	      }
    	    else
    	    {
              search(roll);
            }break;
          }
	case 4 :
    	  {
	     int rn;
	     
             cout<<"\t\t Please enter roll number of the student to be deleted\n";
              cin>>rn;
             delete_student(rn);break;
     	   }
	case 5:
    	{
         
    	 cout<<"\t\t Please enter roll number of the student to be modified\n";
	  int rn;
         cin>>rn;
         modify_student(rn);
         break;
        } 
       }
	  }
      else
      { 
      W1.RenderText(Position(10.0,11.0),Position(16,15),"Incorrect password: try again",Blue);   
      cin>>l;
      }
      
  }       
  if (l=='s') 
      {
	W1.Close();
         W2.Open();
	 assert(W2.GetStatus() == WindowOpen);         
     
	W2.RenderText(Position(2.0,2.0),Position(10,4)," < 1 > . Veiw student info. list  ",Blue);
     
        W2.RenderText(Position(2.0,4.0),Position(10,6)," < 2 > .  Search for a student on Roll.no basis  ",Blue);
       
        W2.RenderText(Position(2.0,6.0),Position(10,8)," < 3 > . Department wise search of students ",Blue);
      
       W2.RenderText(Position(2.0,9.0),Position(10,11),"  Press the number before to got to the coressponding function: ",Blue);   
   
  
      int c; 
      cin>>c;
	W2.Close();
   
 switch(c)
    {
      case 1 :
	   {
        	print_database();break;
	    }
    
   	case 2 :
	   { 
         int roll;
             
             cout<<"\t\tenter your roll no."<<endl;
           	cin>>roll;
      	if(roll/100000000!=1 || roll%1000000000!=roll)
	      {
	    	
            cout<<"\t\t\tinvalid roll"<<endl;return -1;
	      }
    	else
    	  {
          search(roll);
          }break;
        }
     case 3 :
          {
	   char dpt[60];
	    cout<<"\t\t enter department name(in lower case without space)"<<endl;
           cin>>dpt;
	   search_dept(dpt);break;	
	  }
	    
	}
    }
return 0;}



